<?php
/*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
class BzpayPaymentPostpaymentModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function postProcess()
    {
		$authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'bzpaypayment') {
                $authorized = true;
                break;
            }
        }

			if ($this->validate($_REQUEST)== false){
				$this->context->smarty->assign( array(
				'error'=> 'true',
				'cc-name'=>$_REQUEST['card-name'],
				'total'=>$_REQUEST['amount']
		) );


		$this->setTemplate('module:bzpaypayment/views/templates/front/payment_form.tpl');
			}else {
	
	
		$BZPAY_MERCHANT_ID = Configuration::get( 'BZPAY_MERCHANT_ID' );
		$BZPAY_AUTH_KEY = Configuration::get( 'BZPAY_AUTH_KEY' );
		$BZPAY_MSI = Configuration::get( 'BZPAY_MSI' );
		
			
			

		$address1= $_COOKIE['address1'];
		$address2= $_COOKIE['address2'];
		$city= $_COOKIE['city'];
		$country= $_COOKIE['country'];
		$country= $this->code_to_country($country);
		$postcode= $_COOKIE['postcode'];
		$phone= $_COOKIE['phone'];
		$state=$_COOKIE['state'];
		$cart = $this->context->cart;

		
		$environment_url='https://www.bzpay.com.mx/BZPAY_Secure/Capture/TransactionBatch.aspx';

		$useragent = $_SERVER['HTTP_USER_AGENT'];
		$transtime= date("d/m/Y h:i:s");
		$reference= sha1(md5(time()));
		$cardtype=substr($_REQUEST['card-number'],0,1);
					if($cardtype==4){
							$card='Visa';
							}
					if($cardtype==5){
							$card='Mastercard';
							}
			
	        $xml ='<?xml version="1.0" encoding="UTF-8"?>';
		$xml.='<TransactionBatch MerchantID="'.$BZPAY_MERCHANT_ID.'" AuthKey="'.$BZPAY_AUTH_KEY.'" >';
		$xml.='<Transaction SequenceID="1">';
		$xml.='<CCTransaction>';
		$xml.='<TransactionID />';
		$xml.='<Currency>MXN</Currency>';
		$xml.='<Reference>'.$cart->id.'</Reference>';
		$xml.='<TransactionTime>'.$transtime.'</TransactionTime>';
		$xml.='<Notes></Notes>';
		$xml.='<Customer>';
		$xml.='<CustomerID/>';
		$xml.='<CustomerReference>'.$this->context->customer->email.'</CustomerReference>';
		$xml.='<FirstName>'.$this->context->customer->firstname.'</FirstName>';
		$xml.='<Initial></Initial>';
		$xml.='<LastName>'.$this->context->customer->lastname.'</LastName>';
		$xml.='<AddressOne>'.$address1.'</AddressOne>';
		$xml.='<AddressTwo>'.$address2.'</AddressTwo>';
		$xml.='<City>'.$city.'</City>';
		$xml.='<State>'.$state.'</State>';
		//$xml.='<State>AA</State>';
		$xml.='<ZipCode>'.$postcode.'</ZipCode>';
		$xml.='<Email>'.$this->context->customer->email.'</Email>';
		$xml.='<Country>'.$country.'</Country>';
		$xml.='<DateOfBirth></DateOfBirth>';
		$xml.='<Last4SSN></Last4SSN>';
		$xml.='<Phone>'.$phone.'</Phone>';
		$xml.='<UserName>'.$this->context->customer->email.'</UserName>';		
		$xml.='</Customer>';
		$xml.='<Bank>';
		$xml.='<Name></Name>';
		$xml.='<City></City>';
		$xml.='<State></State>';
		$xml.='<Phone></Phone>';
		$xml.='</Bank>';
		$xml.='<IPAddress>'.$_SERVER['REMOTE_ADDR'].'</IPAddress>';
		$xml.='<CardType>'.$card.'</CardType>';
		$xml.='<PaymentType>CC</PaymentType>';
		if ($BZPAY_MSI == true && $_REQUEST['msi-select'] !='Seleccione una opcion' && $_REQUEST["iscc"]== true){
		$xml.='<Promo_Months>'.$_POST['msi-select'].'</Promo_Months>';
		}
		$xml.='<Amount>'.$_REQUEST['amount'].'</Amount>';
		//$xml.='<Amount>1</Amount>';
		$xml.='<NameOnCC>'.$_REQUEST['card-name'].'</NameOnCC>';
		$xml.='<CardNumber>'.$_REQUEST['card-number'].'</CardNumber>';
		$xml.='<ExpMonth>'.$_REQUEST['card-month-exp'].'</ExpMonth>';
		$xml.='<ExpYear>'.$_REQUEST['card-year-exp'].'</ExpYear>';
		$xml.='<CVV>'.$_REQUEST['card-cvc'].'</CVV>';
		$xml.='<UserAgent>'.$useragent.'</UserAgent>';
		$xml.='<HttpAccept>*/*</HttpAccept>';
		$xml.='<GMTO></GMTO>';
		$xml.='<Return_Url>http://localhost:1149/UI/Receive3DResponse.aspx</Return_Url>';
		$xml.='<Domain>'.$_SERVER['SERVER_NAME'].'</Domain>';
		$xml.='<URL3D/>';
		$xml.='<Status/>';
		$xml.='</CCTransaction>';
		$xml.='</Transaction>';
		$xml.='</TransactionBatch>';
		
		

		$headers = array(
			"Content-type: text/xml",
			"Content-length: " . strlen($xml),
			"Connection: close",
			);
		$ch = curl_init(); 
			curl_setopt($ch, CURLOPT_URL,$environment_url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($ch); 
			$xmls = simplexml_load_string($response);
			$xml2j = json_encode($xmls);
			$jxml = json_decode($xml2j);
			$status = $jxml->Transaction->CCTransaction->Status;
		
		if ( $status == 'APPROVED' ) {
			
			$customer = new Customer($cart->id_customer);
				if (!Validate::isLoadedObject($customer))
				Tools::redirect('index.php?controller=order&step=1');
				$currency = $this->context->currency;
				$total = $cart->getOrderTotal();
				$c = Configuration::get('PS_OS_PAYMENT');
				$status_paid= 'APPROVED';

		$this->module->validateOrder($cart->id, $c, $total, $this->module->displayName, NULL,array(), (int)$currency->id, false, $customer->secure_key);                        
		$this->module->storeTransactionID( $reference, $this->module->currentOrder, $_REQUEST['amount'], $captured = 'YES' );
	        Tools::redirect('index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
		$this->setTemplate('module:bzpaypayment/views/templates/front/payment_return.tpl');
		
			}
	
		if ( $status == 'ERROR' ) {
			$error2= $jxml->Transaction->CCTransaction->Errors->Error->Description;
			$customer = new Customer($cart->id_customer);
				if (!Validate::isLoadedObject($customer))
				Tools::redirect('index.php?controller=order&step=1');
				$currency = $this->context->currency;
				$total = $cart->getOrderTotal();
				$c = Configuration::get('PS_OS_PAYMENT');
				$status_paid= 'ERROR';

			$this->module->storeTransactionID( $reference, $cart->id, $_REQUEST['amount'], $captured = 'NO' );
			
 	    	    $this->context->smarty->assign( array(
                    'status' => 'failed',
		    'error'=>$error2,
		    'url'=>'https://'.$_SERVER['SERVER_NAME'].'/devtest/order')
		            );
        
		$this->setTemplate('module:bzpaypayment/views/templates/front/payment_return.tpl');
		
			}
		
    }
	}
	
	function validate($data){
		
		$error=false;
		
		$mastercardstr = '/^(?:5[1-5][0-9]{14})$/';
		$visastr = '/^(?:4[0-9]{12}(?:[0-9]{3})?)$/';
		
		$re = $data['card-number'];
		
		if(preg_match($visastr, $re)){
				return true;
		}
		elseif(preg_match($mastercardstr, $re)){
			return true;
		}else{
			 return false;
			}
		
		
	}
	 function code_to_country($countryname){

	$countrycodes = array(
"Afghanistan"=>"AF",
"\xc3\x85land Islands"=>"AX",
"Albania"=>"AL",
"Algeria"=>"DZ",
"American Samoa"=>"AS",
"Andorra"=>"AD",
"Angola"=>"AO",
"Anguilla"=>"AI",
"Antarctica"=>"AQ",
"Antigua and Barbuda"=>"AG",
"Argentina"=>"AR",
"Armenia"=>"AM",
"Aruba"=>"AW",
"Australia"=>"AU",
"Austria"=>"AT",
"Azerbaijan"=>"AZ",
"Bahamas"=>"BS",
"Bahrain"=>"BH",
"Bangladesh"=>"BD",
"Barbados"=>"BB",
"Belarus"=>"BY",
"Belgium"=>"BE",
"Belize"=>"BZ",
"Benin"=>"BJ",
"Bermuda"=>"BM",
"Bhutan"=>"BT",
"Bolivia, Plurinational State of"=>"BO",
"Bonaire, Sint Eustatius and Saba"=>"BQ",
"Bosnia and Herzegovina"=>"BA",
"Botswana"=>"BW",
"Bouvet Island"=>"BV",
"Brazil"=>"BR",
"British Indian Ocean Territory"=>"IO",
"Brunei Darussalam"=>"BN",
"Bulgaria"=>"BG",
"Burkina Faso"=>"BF",
"Burundi"=>"BI",
"Cambodia"=>"KH",
"Cameroon"=>"CM",
"Canada"=>"CA",
"Cabo Verde"=>"CV",
"Cayman Islands"=>"KY",
"Central African Republic"=>"CF",
"Chad"=>"TD",
"Chile"=>"CL",
"China"=>"CN",
"Christmas Island"=>"CX",
"Cocos (Keeling) Islands"=>"CC",
"Colombia"=>"CO",
"Comoros"=>"KM",
"Congo"=>"CG",
"Congo, The Democratic Republic of the"=>"CD",
"Cook Islands"=>"CK",
"Costa Rica"=>"CR",
"C\xc3\xb4te d'Ivoire"=>"CI",
"Croatia"=>"HR",
"Cuba"=>"CU",
"Cura\xc3\xa7ao"=>"CW",
"Cyprus"=>"CY",
"Czech Republic"=>"CZ",
"Denmark"=>"DK",
"Djibouti"=>"DJ",
"Dominica"=>"DM",
"Dominican Republic"=>"DO",
"Ecuador"=>"EC",
"Egypt"=>"EG",
"El Salvador"=>"SV",
"Equatorial Guinea"=>"GQ",
"Eritrea"=>"ER",
"Estonia"=>"EE",
"Ethiopia"=>"ET",
"Falkland Islands (Malvinas)"=>"FK",
"Faroe Islands"=>"FO",
"Fiji"=>"FJ",
"Finland"=>"FI",
"France"=>"FR",
"French Guiana"=>"GF",
"French Polynesia"=>"PF",
"French Southern Territories"=>"TF",
"Gabon"=>"GA",
"Gambia"=>"GM",
"Georgia"=>"GE",
"Germany"=>"DE",
"Ghana"=>"GH",
"Gibraltar"=>"GI",
"Greece"=>"GR",
"Greenland"=>"GL",
"Grenada"=>"GD",
"Guadeloupe"=>"GP",
"Guam"=>"GU",
"Guatemala"=>"GT",
"Guernsey"=>"GG",
"Guinea"=>"GN",
"Guinea-Bissau"=>"GW",
"Guyana"=>"GY",
"Haiti"=>"HT",
"Heard Island and McDonald Islands"=>"HM",
"Holy See"=>"VA",
"Honduras"=>"HN",
"Hong Kong"=>"HK",
"Hungary"=>"HU",
"Iceland"=>"IS",
"India"=>"IN",
"Indonesia"=>"ID",
"Iran, Islamic Republic of"=>"IR",
"Iraq"=>"IQ",
"Ireland"=>"IE",
"Isle of Man"=>"IM",
"Israel"=>"IL",
"Italy"=>"IT",
"Jamaica"=>"JM",
"Japan"=>"JP",
"Jersey"=>"JE",
"Jordan"=>"JO",
"Kazakhstan"=>"KZ",
"Kenya"=>"KE",
"Kiribati"=>"KI",
"Korea, Democratic People's Republic of"=>"KP",
"Korea, Republic of"=>"KR",
"Kuwait"=>"KW",
"Kyrgyzstan"=>"KG",
"Lao People's Democratic Republic"=>"LA",
"Latvia"=>"LV",
"Lebanon"=>"LB",
"Lesotho"=>"LS",
"Liberia"=>"LR",
"Libya"=>"LY",
"Liechtenstein"=>"LI",
"Lithuania"=>"LT",
"Luxembourg"=>"LU",
"Macao"=>"MO",
"Macedonia, The Former Yugoslav Republic of"=>"MK",
"Madagascar"=>"MG",
"Malawi"=>"MW",
"Malaysia"=>"MY",
"Maldives"=>"MV",
"Mali"=>"ML",
"Malta"=>"MT",
"Marshall Islands"=>"MH",
"Martinique"=>"MQ",
"Mauritania"=>"MR",
"Mauritius"=>"MU",
"Mayotte"=>"YT",
"Mexico"=>"MX",
"Micronesia, Federated States of"=>"FM",
"Moldova, Republic of"=>"MD",
"Monaco"=>"MC",
"Mongolia"=>"MN",
"Montenegro"=>"ME",
"Montserrat"=>"MS",
"Morocco"=>"MA",
"Mozambique"=>"MZ",
"Myanmar"=>"MM",
"Namibia"=>"NA",
"Nauru"=>"NR",
"Nepal"=>"NP",
"Netherlands"=>"NL",
"New Caledonia"=>"NC",
"New Zealand"=>"NZ",
"Nicaragua"=>"NI",
"Niger"=>"NE",
"Nigeria"=>"NG",
"Niue"=>"NU",
"Norfolk Island"=>"NF",
"Northern Mariana Islands"=>"MP",
"Norway"=>"NO",
"Oman"=>"OM",
"Pakistan"=>"PK",
"Palau"=>"PW",
"Palestine, State of"=>"PS",
"Panama"=>"PA",
"Papua New Guinea"=>"PG",
"Paraguay"=>"PY",
"Peru"=>"PE",
"Philippines"=>"PH",
"Pitcairn"=>"PN",
"Poland"=>"PL",
"Portugal"=>"PT",
"Puerto Rico"=>"PR",
"Qatar"=>"QA",
"R\xc3\xa9union"=>"RE",
"Romania"=>"RO",
"Russian Federation"=>"RU",
"Rwanda"=>"RW",
"Saint Barth\xc3\xa9lemy"=>"BL",
"Saint Helena, Ascension and Tristan Da Cunha"=>"SH",
"Saint Kitts and Nevis"=>"KN",
"Saint Lucia"=>"LC",
"Saint Martin (French part)"=>"MF",
"Saint Pierre and Miquelon"=>"PM",
"Saint Vincent and the Grenadines"=>"VC",
"Samoa"=>"WS",
"San Marino"=>"SM",
"Sao Tome and Principe"=>"ST",
"Saudi Arabia"=>"SA",
"Senegal"=>"SN",
"Serbia"=>"RS",
"Seychelles"=>"SC",
"Sierra Leone"=>"SL",
"Singapore"=>"SG",
"Sint Maarten (Dutch part)"=>"SX",
"Slovakia"=>"SK",
"Slovenia"=>"SI",
"Solomon Islands"=>"SB",
"Somalia"=>"SO",
"South Africa"=>"ZA",
"South Georgia and the South Sandwich Islands"=>"GS",
"South Sudan"=>"SS",
"Spain"=>"ES",
"Sri Lanka"=>"LK",
"Sudan"=>"SD",
"Suriname"=>"SR",
"Svalbard and Jan Mayen"=>"SJ",
"Swaziland"=>"SZ",
"Sweden"=>"SE",
"Switzerland"=>"CH",
"Syrian Arab Republic"=>"SY",
"Taiwan, Province of China"=>"TW",
"Tajikistan"=>"TJ",
"Tanzania, United Republic of"=>"TZ",
"Thailand"=>"TH",
"Timor-Leste"=>"TL",
"Togo"=>"TG",
"Tokelau"=>"TK",
"Tonga"=>"TO",
"Trinidad and Tobago"=>"TT",
"Tunisia"=>"TN",
"Turkey"=>"TR",
"Turkmenistan"=>"TM",
"Turks and Caicos Islands"=>"TC",
"Tuvalu"=>"TV",
"Uganda"=>"UG",
"Ukraine"=>"UA",
"United Arab Emirates"=>"AE",
"United Kingdom of Great Britain and Northern Ireland"=>"GB",
"United States of America"=>"US",
"United States"=>"US",
"United States Minor Outlying Islands"=>"UM",
"Uruguay"=>"UY",
"Uzbekistan"=>"UZ",
"Vanuatu"=>"VU",
"Venezuela, Bolivarian Republic of"=>"VE",
"Viet Nam"=>"VN",
"Virgin Islands, British"=>"VG",
"Virgin Islands, U.S."=>"VI",
"Wallis and Futuna"=>"WF",
"Western Sahara"=>"EH",
"Yemen"=>"YE",
"Zambia"=>"ZM",
"Zimbabwe"=>"ZW"
);
  if( !$countrycodes[$countryname]) return $countryname;
    else return $countrycodes[$countryname];
	 
	 }
}
