<?php
/*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
class BzpayPaymentValidationModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function postProcess()
    {
        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'bzpaypayment') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }
        $msi = Configuration::get('BZPAY_MSI');
        $BZPAY_MSI_3= Configuration::get('BZPAY_MSI_3');
        $BZPAY_MSI_6= Configuration::get('BZPAY_MSI_6');
        $BZPAY_MSI_9= Configuration::get('BZPAY_MSI_9');
        $BZPAY_MSI_12= Configuration::get('BZPAY_MSI_12');
        $MSI_PROMO_3= Configuration::get('MSI_PROMO_3');
		$MSI_PROMO_6= Configuration::get('MSI_PROMO_6');
		$MSI_PROMO_9= Configuration::get('MSI_PROMO_9');
		$MSI_PROMO_12= Configuration::get('MSI_PROMO_12');
		$total = $cart->getOrderTotal();
		$cart_total=str_replace('.00','',$total);
			if ($MSI_PROMO_3 == true){
			$p1 =  '<option value="3">3 Meses</option>';
			}
			if ($MSI_PROMO_6 == true){
			$p2 =  '<option value="6">6 Meses</option>';
			}
			if ($MSI_PROMO_9 == true){
			$p3 =  '<option value="9" >9 Meses</option>';
			}
			if ($MSI_PROMO_12 == true){
			$p4 =  '<option value="12">12 Meses</option>';
			}
			
			
		$this->context->smarty->assign( array(
			'total'=> $total,
			'msi'=> $msi,
			'msi3'=> $BZPAY_MSI_3,
			'msi6'=> $BZPAY_MSI_6,
			'ms9'=> $BZPAY_MSI_9,
			'msi12'=> $BZPAY_MSI_12,
			'msi_promo3'=> $MSI_PROMO_3,
			'msi_promo6'=> $MSI_PROMO_6,
			'msi_promo9'=> $MSI_PROMO_9,
			'msi_promo12'=> $MSI_PROMO_12,
			'p1'=> $p1, 
			'p2'=> $p2, 
			'p3'=> $p3,
			'p4'=> $p4, 
			'cart_total'=> $cart_total,
			'error'=>'false'
		) );
		$this->setTemplate('module:bzpaypayment/views/templates/front/payment_form.tpl');
		
    }
}
